<?php
################################################################################
##              -= YOU MAY NOT REMOVE OR CHANGE THIS NOTICE =-                 #
## --------------------------------------------------------------------------- #
##  ApPHP AJAX File Uploader version 2.2.5 						               #
##  Developed by:  ApPHP <info@apphp.com>                                      #
##  License:       GNU GPL v.2                                                 #
##  Site:          http://www.apphp.com/php-file-uploader/                     #
##  Copyright:     ApPHP AJAX File Uploader (c) 2011-2012. All rights reserved.#
##  Additional modules (embedded):                                             #
##  -- jQuery v1.8.3 (JavaScript Library)                                      #
##  -- jQuery Form v3.23 (JavaScript Library)                                  #
##                                                                             #
################################################################################
class FileUploader
{
	// PUBLIC
    // -------
    // constructor
    // AddAllowedExtension
    // AddAllowedLanguage
    // AddHiddenField
    // Display
    // DisplayViewer


    // SETTERS					GETTERS
    // -------              	-------
    // Debug					GetDebug
 	// SetFolder				GetFolder
    // SetId					GetId
    // SetStyle					GetStyle
    // ShowProgress				IsShowingProgress
    // UseRandomNames			IsUsingRandomNames
    // SetNumColumnsForViewer 	GetNumColumnsForViewer
    // AllowDeleteFiles
    // OverwriteFiles
    // SetLanguage
    // SetMaxSize
    // SetNumberOfFiles
    // ShowClearAllButton
    // ShowFileSizeAfterUpload
    // ShowIcons
    // ShowUploadAllButton
    // LoadFilesOnSelect
    // UsePostfix
    // UsePrefix
    // UseSuffixes
    // UseYesNoPictures
    // CreateFolderIfNeeded

    // PUBLIC STATIC
    // --------
    // DisplayRow
    // DisplayForm
    // GetParam
    // ReadFiles
    // GetFolderSeparator
    // IncludeJsAndCssFiles

    // PRIVATE
    // CheckUploadStatus
    // GetLocalizedString
    // LoadUIStrings


    // PRIVATE STATIC
    // CheckInput
    // ChooseIcon
    // ConvertSizeToBytes



	//--- PRIVATE DATA MEMBERS --------------------------------------------------
	private $allowedLanguages = array('en','de');
	private static $allowedStyles = array('dark','light','simple');
	private $numOfFiles = 3;
	private $allowedExtensions = '|';
	private $httpVarsKeys = '|';
	private $httpVarsValues = '|';
	private $size = '';
	private $id = 1;
	private $progressMessage;
	private $folder = 'uploadedfiles';
	private $showingProgress = false;
	private $showingIcons = true;
	private $overwritingFiles = true;
	private $usingRandomNames = false;
	private $usingSuffixes = false;
	private $usingYesNoPictures = true;
	private $showingClearAllButton = true;
	private $showingFileSizeAfterUpload = true;
	private $showingUploadAllButton = true;
	private $deletingFilesAllowed = false;
	private $loadingFilesOnSelect = false;
	private $style='dark';
	private $path;
	private $prefix='';
	private $postfix='';
	private $isDebug = false;
	private $maxNumFiles = 0;
	private $warningMessages = array();
	private $language = 'en';
	private $dictionary = array();
    private $httpVars = array();
    private $nl = "\n";
    private $createFolderIfNeeded = false;
    private $numViewerColumns = 1;

	//--- CONSTANTS -------------------------------------------------------------
    const version='2.2.5';
    const jQueryVersion='1.8.3';

    /**
    *	Creates a file uploader object
    *
    */
	public function __construct()
	{
 		$this->path = defined('UPLOADER_DIR') ? UPLOADER_DIR : '';
 		if(session_id() == '') {
    		session_start();
		}
		include_once('resources/config.php');
		$_SESSION['uploader_password']=$dictionary['Password'];
    }
    /**
    * Includes CSS and JavaScript files used by the script
    *
    */
    public static function IncludeJsAndCssFiles($style='',$language='en')
    {
    	$nl = "\n";
    	$output = '';
    	$path = defined('UPLOADER_DIR') ? UPLOADER_DIR : '';
    	///$output.= $nl.'<script type="text/javascript" src="'.$path.'js/jquery-'.self::jQueryVersion.'.min.js"></script>';
		$output.= $nl.'<script>window.jQuery || document.write(\'<script type="text/javascript" src="'.$path.'js/jquery-'.self::jQueryVersion.'.min.js">\x3C/script>\')</script>';
        $output.= $nl.'<script type="text/javascript" src="'.$path.'js/jquery.form.js"></script>';
        $output.= $nl.'<script type="text/javascript" defer="defer" src="'.$path.'js/script.js"></script>';
        $output.= $nl.'<script type="text/javascript" defer="defer" src="'.$path.'js/res-'.$language.'.js"></script>';
        $output.= $nl.'<link href="'.$path.'styles/common.css" rel="stylesheet" type="text/css" />';
        if($style == '')
        {
        	foreach(self::$allowedStyles as $allowedStyle)
        		$output.= $nl.'<link href="'.$path.'styles/'.$allowedStyle.'/style.css" rel="stylesheet" type="text/css" />';
        }
        else $output.= $nl.'<link href="'.$path.'styles/'.$style.'/style.css" rel="stylesheet" type="text/css" />';
        define('UPLOADER_FILES_INCLUDED',true);
        echo $output;
    }
    /**
    * Displays all UI elements which are necessary for file uploading
    * @param bool $csrf_check
    */
    public function Display($csrf_check = true)
    {
        $this->LoadUIStrings($csrf_check);

        $output = '';
        $output.= $this->nl.'<div class="uploader_mainDiv_'.$this->style.'">';
        if(!defined('UPLOADER_FILES_INCLUDED') || UPLOADER_FILES_INCLUDED === false)
        	self::IncludeJsAndCssFiles($this->style, $this->language);

        if($this->showingProgress)
           $this->CheckUploadStatus();
        else $this->progressMessage = 'Show progress option is turned off';
        $output.= $this->nl.'<div class="uploader_container">';
        $output.= $this->nl.'<div class="uploader_tablecontainer">';
        $output.= $this->nl.'<table id="uploadertable'.$this->id.'" class="uploader_table" cellpadding="0" cellspacing="0" style="width:100%">';
        $output.= $this->nl.'<tbody id="uploadertable_body'.$this->id.'">';
        //$output.= self::DisplayRow($this->id,$this->path,$this->style,$this->showingProgress,$this->showingIcons,$this->showingYesNoPictures,0);
        $output.= $this->nl.'</tbody>';
        $output.= $this->nl.'</table>';
        $output.= $this->nl.'</div>';
        $output.= $this->nl.'<div id="message'.$this->id.'" class="message" style="display:none;width:100%"></div>';
        $output.= $this->nl.'<div class="buttoncontainer">';
        $output.= $this->nl.'<div class="uploader_buttonaligned">';
        $output.= $this->nl.'<div class="fileinputs">';
        $output.= $this->nl.'<div id="uploader_forms'.$this->id.'">';
        $output.= $this->nl.'<form name="__uploaderForm'.$this->id.'" id="form'.$this->id.'-0" action="'.$this->path.'lib/upload_result.php" enctype="multipart/form-data" method="post">';
        $output.= self::DisplayForm($this->id,$this->style,$this->path,$this->allowedExtensions,self::ConvertSizeToBytes($this->size),$this->folder,$this->usingRandomNames,$this->usingSuffixes,$this->prefix,$this->postfix,0,'',$this->httpVars,$this->overwritingFiles);
        $output.= $this->nl.'</form>';
        $output.= $this->nl.'</div>';
        $output.= $this->nl.'<div class="fakefile">';
        //$output.= '<img class="uploader_'.$this->style.'_button" id="addimagebutton'.$this->id.'" alt="" src="'.$this->path.'styles/'.$this->style.'/images/add_regular.jpg" />';
        if($this->style=='simple')
          $output.= $this->nl.'<input type="button" id="addimagebutton'.$this->id.'" value="'.$this->GetLocalizedString('Add_ButtonText').'" class="uploader_button" />';
        else
        {
        	$output.= $this->nl.'<div class="uploader_imagecontainer" id="addimagediv'.$this->id.'">';
        	$output.= $this->nl.'<img class="uploader_button" id="addimagebutton'.$this->id.'" src="'.$this->path.'styles/'.$this->style.'/images/button_regular.jpg" />';
 			$output.= $this->nl.'<div class="uploader_imagecaption">'.$this->GetLocalizedString('Add_ButtonText').'</div>';
  			$output.= $this->nl.'</div>';
  	    }

        $output.= $this->nl.'</div>';
        $output.= $this->nl.'</div>';
        $output.= $this->nl.'<div class="fileinputs">';
        if($this->showingUploadAllButton)
        {
       		 if($this->style=='simple')
       		    $output.= $this->nl.'<input type="button" id="uploadallbutton'.$this->id.'" class="uploader_button" value="'.$this->GetLocalizedString('UploadAll_ButtonText').'" onclick="__uploader_uploadall('.$this->id.')" />';
       		 //else $output.= $this->nl.'<img id="uploadallbutton'.$this->id.'" alt="" src="'.$this->path.'styles/'.$this->style.'/images/upload_regular.jpg" class="uploader_'.$this->style.'_button" onclick="__uploader_uploadall('.$this->id.')" />';
       		 else
        	 {
        		$output.= $this->nl.'<div class="uploader_imagecontainer" onclick="__uploader_uploadall('.$this->id.')">';
        		$output.= $this->nl.'<img src="'.$this->path.'styles/'.$this->style.'/images/button_regular.jpg" />';
 				$output.= $this->nl.'<div class="uploader_imagecaption">'.$this->GetLocalizedString('UploadAll_ButtonText').'</div>';
  				$output.= $this->nl.'</div>';
  	    	 }
        }
        $output.= $this->nl.'</div>';
        $output.= $this->nl.'<div class="fileinputs">';
        if($this->showingClearAllButton)
        {
       		 if($this->style=='simple')
       		    $output.= $this->nl.'<input type="button" id="clearallbutton'.$this->id.'" class="uploader_button" value="'.$this->GetLocalizedString('ClearAll_ButtonText').'" onclick="__uploader_clearall('.$this->id.')" />';
       		 //else $output.= $this->nl.'<img id="clearallbutton'.$this->id.'" alt="" src="'.$this->path.'styles/'.$this->style.'/images/clear_regular.jpg" class="uploader_'.$this->style.'_button" onclick="__uploader_clearall('.$this->id.')" />';
       		 else
        	 {
        		$output.= '<div class="uploader_imagecontainer" onclick="__uploader_clearall('.$this->id.')">';
        		$output.= $this->nl.'<img src="'.$this->path.'styles/'.$this->style.'/images/button_regular.jpg" />';
 				$output.= $this->nl.'<div class="uploader_imagecaption">'.$this->GetLocalizedString('ClearAll_ButtonText').'</div>';
  				$output.= $this->nl.'</div>';
  	    	 }
        }
        $output.= $this->nl.'</div>';
        $output.= $this->nl.'</div>';
        $output.= $this->nl.'</div>';
        $output.= $this->nl.'</div>';
        $pathToUploadedFolder = dirname(__FILE__).self::GetFolderSeparator().$this->folder;
        if (!file_exists($pathToUploadedFolder) && $this->createFolderIfNeeded)
        	if(!mkdir($pathToUploadedFolder))
        		$this->warningMessages['C'] = 'Failed to create '.$this->folder;
        if($this->GetDebug())
        {
        	 if(!file_exists($pathToUploadedFolder))
        	 {
        	 	$this->warningMessages['A'] = 'The folder selected for uploads ('.$this->folder.') does not exist';
             }
        	 else if(!is_writable($pathToUploadedFolder))
        	 	$this->warningMessages['B'] = 'The folder selected for uploads ('.$this->folder.') is not writable';
             if(session_id() == '')
             	$this->warningMessages['C'] = 'Unable to start session';
        	 $output.= $this->nl.'<div class="progressmessage" id="progressmessage'.$this->id.'">';
	   	     $output.= $this->progressMessage;
	   	     $output.= '</div>';
	   	     if(count($this->warningMessages)>0)
	   	     {
	   	     	$output.= '<ul>';
	   	     	foreach($this->warningMessages as $warningMessage)
	   	     		$output.= '<li>'.$warningMessage.'</li>';
		   	    $this->warningMessages = array();
		        $output.= '</ul>';
		     }
	    }

	    $output.= $this->nl.'<div><iframe class="iframe" id="ifr'.$this->id.'" frameborder="0" style="display:none"></iframe></div>';
        for($i=0;$i<$this->numOfFiles;$i++)
        {
       	     if($this->GetDebug())
       		 {
   	   			 $output.= $this->nl.'<div class="progressstatus" id="progressstatus'.$this->id.'-'.$i.'"></div>';
       		 }
        }
        $output.= $this->nl.'<input type="hidden" id="httpVarsKeys'.$this->id.'" name="httpVarsKeys" value="'.$this->httpVarsKeys.'" />';
        $output.= $this->nl.'<input type="hidden" id="httpVarsValues'.$this->id.'" name="httpVarsValues" value="'.$this->httpVarsValues.'" />';
        $output.= $this->nl.'<input type="hidden" id="uploading'.$this->id.'" value="0" />';
        $output.= $this->nl.'<input type="hidden" id="style'.$this->id.'" value="'.$this->style.'" />';
        $output.= $this->nl.'<input type="hidden" id="index'.$this->id.'" value="0" />';
        $output.= $this->nl.'<input type="hidden" id="numfiles'.$this->id.'" value="'.$this->numOfFiles.'" />';
        $output.= $this->nl.'<input type="hidden" id="maxNumFiles'.$this->id.'" value="'.$this->maxNumFiles.'" />';
        $output.= $this->nl.'<input type="hidden" id="extensions'.$this->id.'" value="'.$this->allowedExtensions.'" />';
        $output.= $this->nl.'<input type="hidden" id="showProgress'.$this->id.'" value="'.$this->showingProgress.'" />';
        $output.= $this->nl.'<input type="hidden" id="deleteFilesAllowed'.$this->id.'" value="'.$this->deletingFilesAllowed.'" />';
        $output.= $this->nl.'<input type="hidden" id="numViewerColumns'.$this->id.'" value="'.$this->numViewerColumns.'" />';
        $output.= $this->nl.'<input type="hidden" id="overwriteFiles'.$this->id.'" value="'.$this->overwritingFiles.'" />';
        $output.= $this->nl.'<input type="hidden" id="showFileSizeAfterUpload'.$this->id.'" value="'.$this->showingFileSizeAfterUpload.'" />';
        $output.= $this->nl.'<input type="hidden" id="showIcons'.$this->id.'" value="'.$this->showingIcons.'" />';
        $output.= $this->nl.'<input type="hidden" id="folder'.$this->id.'" value="'.$this->folder.'" />';
        $output.= $this->nl.'<input type="hidden" id="useRandomNames'.$this->id.'" value="'.$this->usingRandomNames.'" />';
        $output.= $this->nl.'<input type="hidden" id="useSuffixes'.$this->id.'" value="'.$this->usingSuffixes.'" />';
        $output.= $this->nl.'<input type="hidden" id="useYesNoPictures'.$this->id.'" value="'.$this->usingYesNoPictures.'" />';
        $output.= $this->nl.'<input type="hidden" id="loadFilesOnSelect'.$this->id.'" value="'.$this->loadingFilesOnSelect.'" />';
        $output.= $this->nl.'<input type="hidden" id="prefix'.$this->id.'" value="'.$this->prefix.'" />';
        $output.= $this->nl.'<input type="hidden" id="postfix'.$this->id.'" value="'.$this->postfix.'" />';
        $output.= $this->nl.'<input type="hidden" id="showDebugInfo'.$this->id.'" value="'.$this->GetDebug().'" />';
        $output.= $this->nl.'<input type="hidden" id="uploadfolder'.$this->id.'" value="'.$this->folder.'" />';
        $output.= $this->nl.'<input type="hidden" id="path'.$this->id.'" value="'.$this->path.'" />';
        if($this->size == '' || self::ConvertSizeToBytes(ini_get("upload_max_filesize")) < self::ConvertSizeToBytes($this->size)){
            $max = ini_get('upload_max_filesize');
        }else{
            $max = $this->size;
        }
        $output.= $this->nl.'<input type="hidden" id="size'.$this->id.'" value="'.$max.'" />';
        $output.= $this->nl.'<input type="hidden" id="sizebytes'.$this->id.'" value="'.self::ConvertSizeToBytes($max).'" />';
        $output.= $this->nl.'</div>';
        $output.= $this->nl.'<!-- END This code was generated by fileuploader.class.php v'.self::version.'(http://www.apphp.com/php-file-uploader/index.php) END -->'.$this->nl;
        echo $output;
    }

    /**
    * Displays a row in the progress table
    	@param $id - uploader object's id
    	@param $path - path to uploader object
    	@param $style
    	@param $showingProgress - whether progress is showed during file uploading (true|false)
    	@param $showingIcons - whether file icons are shown (true|false)
    	@param $usingYesNoPictures - whether pictures or clickable images will be used for 'upload' and 'remove' commands
    	@param $filename
    	@param $i - this row's number
    *
    */
    public static function DisplayRow($id,$path,$style,$showingProgress,$showingIcons,$usingYesNoPictures,$filename,$i)
    {
		$output = '';
        $nl = "\n";
		$output.= $nl.'<input type="hidden" id="numFiles'.$id.'-'.$i.'" name="numFiles" value="'.count($filename).'" />';
		//$output.= $nl.'<tr id="row'.$id.'-'.$i.'">';
    	$output.= $nl.'<div class="uploader_tablerow">';
     	$output.= $nl.'<table cellspacing="1" cellpadding="1" style="width:100%"><tbody>';
      	$output.= $nl.'<tr style="width:100%">';
       	if($showingIcons)
	    	$output.= $nl.'<td rowspan="2"><div class="fileicon_div"><img id="image'.$id.'-'.$i.'-0" src="'.self::ChooseIcon($path,$filename[0]).'" alt="" /></div></td>';
      	$output.= $nl.'<td style="width:80%" class="filename" id="filename'.$id.'-'.$i.'-0"><span id="filenamevalue'.$id.'-'.$i.'-0" style="display:none"></span>'.$filename[0].'</td>';
        $output.= $nl.'<td style="width:20%;text-align:right" id="column'.$id.'-'.$i.'">';
        if($usingYesNoPictures){
	    	$output.= $nl.'<img class="commandimage" alt="" src="'.$path.'styles/'.$style.'/images/up.gif" onclick="__uploader_load('.$id.','.$i.')" id="uploadlink'.$id.'-'.$i.'" />';
	        $output.= $nl.'<img class="commandimage" alt="" src="'.$path.'styles/'.$style.'/images/no.gif" onclick="__uploader_cancel('.$id.','.$i.')" id="removelink'.$id.'-'.$i.'" />';
	    }else{
	        $output.= $nl.'<a class="hyperlink" onclick="__uploader_load('.$id.','.$i.')" id="uploadlink'.$id.'-'.$i.'">Upload_LinkText</a><br/>';
	        $output.= $nl.'<a class="hyperlink" onclick="__uploader_cancel('.$id.','.$i.')" id="removelink'.$id.'-'.$i.'">Remove_LinkText</a>';
	    }
        $output.= $nl.'</td>';
        $output.= $nl.'</tr>';
        $output.= $nl.'<tr>';
        $output.= $nl.'<td style="width:80%">';
        if($showingProgress)
        {
           	$output.= $nl.'<table id="progresstable'.$id.'-'.$i.'-0" class="uploader_progresstable" style="float:left" cellspacing="0" cellpadding="0" style="display:none"><tr>';
           	$output.= $nl.'<td width="0%" id="leftcolumn'.$id.'-'.$i.'-0" class="uploader_progressfilled"></td>';
           	$output.= $nl.'<td width="100%" id="rightcolumn'.$id.'-'.$i.'-0" class="uploader_progressleft"></td>';
           	$output.= $nl.'</tr></table>';
        }
        $output.= '<div id="status'.$id.'-'.$i.'-0" style="display:none" class="uploader_status">0%</div>';
        $output.= $nl.'<div id="output'.$id.'-'.$i.'-0" class="uploader_output"></div>';
        $output.= $nl.'</td>';
        $output.= $nl.'<td style="width:20%"></td>';
        $output.= $nl.'</tr>';
        $output.= $nl.'</tbody></table>';
        $output.= $nl.'<input type="hidden" id="statuses'.$id.'-'.$i.'" />';
       	$output.= $nl.'</div>';
       	//$output.= $nl.'</tr>';
       	return $output;
    }

	/**
    * Displays a form for file uploading
        @param $id - uploader object's id
    	@param $style
    	@param $path - path to uploader's object
    	@param $allowedExtensions - list of allowed extensions
    	@param $size - maximal allowed size for files
    	@param $folder - folder where uploaded files are moved to
    	@param $usingRandomNames - whether uploaded files are given random generated names
    	@param $usingSuffixes - Defines what to do when file names are identical
    							true means suffixes will be added to new files' names
	                      		false means files will be overwritten
    	@param $prefix - prefix which will be added to uploaded files' names
    	@param $postfix - postfix which will be added to uploaded files' names
    	@param $index - this form's number
    	@param $enabled - whether the form is enabled (true|false)
    	@param $httpVars - array of custom hidden fields that will be added to the form
    	@param $overwritingFiles - whether existing files will be overwritten
    *
    */
    public static function DisplayForm($id,$style,$path,$allowedExtensions,$size,$folder,$usingRandomNames,$usingSuffixes,$prefix,$postfix,$index,$enabled,$httpVars,$overwritingFiles)
    {
        $nl = "\n";
    	$output = '';

    	 $identifier = md5(microtime().rand());
         foreach(array_keys($httpVars) as $key)
         	$output.= $nl.'<input type="hidden" name="'.$key.'" value="'.$httpVars[$key].'" />';

         $output.= $nl.'<input type="hidden" name="index" value="'.$index.'" />';
         $output.= $nl.'<input type="hidden" name="controlid" value="'.$id.'" />';
         $output.= $nl.'<input type="hidden" name="extensions" value="'.$allowedExtensions.'" />';
         $output.= $nl.'<input type="hidden" name="size" value="'.$size.'" />';
         $output.= $nl.'<input type="hidden" name="folder" value="'.$folder.'" />';
         $output.= $nl.'<input type="hidden" name="userandomnames" value="'.$usingRandomNames.'" />';
         $output.= $nl.'<input type="hidden" name="usesuffixes" value="'.$usingSuffixes.'" />';
         $output.= $nl.'<input type="hidden" name="overwritefiles" value="'.$overwritingFiles.'" />';
         $output.= $nl.'<input type="hidden" name="name" id="name'.$id.'-'.$index.'" value="" />';
         if($prefix!='')
             $output.= $nl.'<input type="hidden" name="prefix" value="'.$prefix.'" />';
         if($postfix!='')
             $output.= $nl.'<input type="hidden" name="postfix" value="'.$postfix.'" />';
         $output.= $nl.'<input type="hidden" id="identifier'.$id.'-'.$index.'" name="UPLOAD_IDENTIFIER" value="'.$identifier.'" />';
         if($style=='simple')
            $inputStyle='simplefile';
         else $inputStyle='file';

    	 $output.= $nl.'<input type="file" size="2" class="'.$inputStyle.'" onchange="onselectfile('.$id.')" id="file'.$id.'-'.$index.'" name="file'.$id.'-'.$index.'[]" ';
    	 if($enabled=='false')
    	    $output.= 'disabled="disabled"';
    	 $output.= '/>';
    	 return $output;
    }

    /**
    * Sets maximal allowed size for files
          @param $size
    *
    */
    public function SetMaxSize($size)
    {
        $this->size=strtolower($size);
    }

    /**
    * Adds an extension to the list of allowed extensions
          @param $extension
    *
    */
    public function AddAllowedExtension($extension)
    {
    	if(is_array($extension)){
    	    foreach($extension as $ext)
    	       if(strlen($ext)>1&&strlen($ext)<5)
    	         $this->allowedExtensions.=$ext.'|';
    	}else{
    	 	if(strlen($extension)>1&&strlen($extension)<5)
    	 	   $this->allowedExtensions.=$extension.'|';
        }
    }

    /**
    * Sets uploader's unique identifier
          @param $id
    *
    */
    public function SetId($id)
    {
        $this->id=$id;
    }

    /**
	*	Gets uploader's unique identifier
	*
	*/
    public function GetId()
    {
       return $this->id;
    }

    /**
    * Sets folder where uploaded files are moved to
          @param $folder
    *
    */
    public function SetFolder($folder)
    {
    	if(!is_string($folder) || strlen($folder) == 0) return;
    	if($folder[strlen($folder)-1]!=self::GetFolderSeparator())
      		$folder = $folder.self::GetFolderSeparator();
      	$this->folder=$folder;
    }

    /**
	*	Gets folder where uploaded files are moved to
	*
	*/
    public function GetFolder()
    {
       return $this->folder;
    }

    /**
    * Sets UI language
          @param $language
    *
    */
    public function SetLanguage($language)
    {
        if(in_array($language,$this->allowedLanguages)){
        	$this->language = $language;
        }
    }

    /**
    * 	Adds a language to the list of allowed languages
          @param $language
    *
    */
    public function AddAllowedLanguage($language)
    {
        $this->allowedLanguages[count($this->allowedLanguages)]=$language;
    }

    /**
    * Loads a resource file for the current language
    * @param bool $csrf_check
    */
    private function LoadUIStrings($csrf_check = true)
    {
		if(!$csrf_check){
			include('resources/resources.'.$this->language.'.php');	
		}else{
			include_once('resources/resources.'.$this->language.'.php');	
		}
    }

    /**
    * 	Gets a localized sting
    		@param $key
    *
    */
    private function GetLocalizedString($key)
    {
     	return $this->dictionary[$key];
    }

    /**
    * 	Adds a custom hidden field to the form being submitted
          @param $name - field's name
          @param $value - field's value
    *
    */
    public function AddHiddenField($name, $value)
    {
        $this->httpVars[$name]=$value;
        $this->httpVarsKeys.= $name.'|';
        $this->httpVarsValues.= $value.'|';
    }


    /**
    * Sets the maximum number of files that the user is allowed to upload simultaneously
          @param $numOfFiles
    *
    */
    public function SetNumberOfFiles($numOfFiles)
    {
        if(is_int($numOfFiles) && $numOfFiles > 0){
			$this->numOfFiles = $numOfFiles;
		}else{
			if($this->isDebug) $this->warningMessages['C'] = 'Maximum number of files that user is allowed to upload must be a positive integer';
		}
    }
	/**
	*	Sets style
	     @param $style - new style
	*
	*/
    public function SetStyle($style)
    {
    	if(file_exists($this->path.'styles/'.$style.'/style.css'))
    	{
    	   $this->style=$style;
    	   if($style=='simple')
		   {
				$this->UseYesNoPictures(false);
    	   	    //$this->ShowIcons(false);
    	  	   //$this->ShowUploadAllButton(false);
			   //$this->ShowClearAllButton(false);
			}
    	}
    }

    /**
	*	Returns uploader's style
	*/
    public function GetStyle()
    {
    	return $this->style;
    }

    /**
	 *	Sets debug mode
	 *		@param $mode
	 */
	public function Debug($mode = false)
	{
		if($mode === true || strtolower($mode) == 'true') $this->isDebug = true;
	}

    /**
	 *	Gets debug mode
	 */
	public function GetDebug()
	{
		return $this->isDebug;
	}

    /**
	 *	Sets whether progress is showed during file uploading
	 *		@param $show - true|false
	 */
	public function ShowProgress($show = false)
	{
		if($show === true || strtolower($show) == 'true') $this->showingProgress = true;
	}

	/**
	 *	Returns whether progress is showed during file uploading
	 */
	public function IsShowingProgress()
	{
		return $this->showingProgress;
	}

	 /**
	 *	Sets whether user is allowed to delete a file after it has been uploaded
	 *		@param $allow - true|false
	 */
	public function AllowDeleteFiles($allow = false)
	{
		if($allow === true || strtolower($allow) == 'true') $this->deletingFilesAllowed = true;
	}

   /**
	 *	Sets whether file's size is displayed after it has been uploaded
	 *		@param $show - true|false
	 */
	public function ShowFileSizeAfterUpload($show = false)
	{
		if($show === true || strtolower($show) == 'true') $this->showingFileSizeAfterUpload = true;
		if($show === false || strtolower($show) == 'false') $this->showingFileSizeAfterUpload = false;
	}

	/**
	 *	Sets whether file icons are shown
	 *		@param $show - true|false
	 */
	public function ShowIcons($show = true)
	{
		if($show === false || strtolower($show) == 'false') $this->showingIcons = false;
	}

	/**
	 *	Defines what to do when file names are identical
	 *		@param $use - true means suffixes will be added to new files' names
	                      false means files will be overwritten
	 */
	public function UseSuffixes($use = false)
	{
		if($use === true || strtolower($use) == 'true') $this->usingSuffixes = true;
	}

	/**
	 *	Defines whether the folder for uploaded files should be created if it doesn't exist
	 		@param $create
     *
	 */
	public function CreateFolderIfNeeded($create = false)
	{
		if($create === true || strtolower($create) == 'true') $this->createFolderIfNeeded = true;
	}
	/**
	 *	Sets whether uploaded files are given random generated names
	 *		@param $use - true|false
	 */
	public function UseRandomNames($use = false)
	{
		if($use === true || strtolower($use) == 'true') $this->usingRandomNames = true;
	}

	/**
	 *	Gets whether uploaded files are given random generated names
	 */
	public function IsUsingRandomNames()
	{
		return $this->usingRandomNames;
	}

	/**
	 *	Sets whether existing files are overwritten
	 *		@param $overwrite - true|false
	 */
	public function OverwriteFiles($overwrite = false)
	{
		if($overwrite === true || strtolower($overwrite) == 'true') $this->overwritingFiles = true;
		if($overwrite === false || strtolower($overwrite) == 'false') $this->overwritingFiles = false;
	}
    /**
	 *	Sets number of columns used in File Viewer
	 *		@param $numColumns - integer
	 */
	public function SetNumColumnsForViewer($numColumns = false)
	{
		if (is_int($numColumns)) $this->numViewerColumns = $numColumns;
	}
	/**
	 *	Gets number of columns used in File Viewer
	 *
	 */
	public function GetNumColumnsForViewer()
	{
		return $this->numViewerColumns;
	}
	/**
	 *	Sets whether pictures or clickable images will be used for 'upload' and 'remove' commands
	 *		@param $use - true means clickable images
	                      false means pictures
	 */
	public function UseYesNoPictures($use = false)
	{
		if($use === false || strtolower($use) == 'false') $this->usingYesNoPictures = false;
	}

	/**
	 *	Sets whether 'Clear all' button is visible
	 *		@param $show
	 */
	public function ShowClearAllButton($show = false)
	{
		if($show === false || strtolower($show) == 'false') $this->showingClearAllButton = false;
	}

	/**
	 *	Sets whether 'Upload all' button is visible
	 *		@param $show
	 */
	public function ShowUploadAllButton($show = false)
	{
		if($show === false || strtolower($show) == 'false') $this->showingUploadAllButton = false;
	}

	/**
	 *	Sets whether file uploading begins immediately after selection
	 *		@param $select
	 */
	public function LoadFilesOnSelect($select = false)
	{
		if($select === false || strtolower($select) == 'false') $this->loadingFilesOnSelect = false;
		if($select === true || strtolower($select) == 'true') $this->loadingFilesOnSelect = true;
	}
	/**
	 *	Sets prefix which will be added to uploaded files' names
	 *		@param $prefix
	 */
	public function UsePrefix($prefix)
	{
		$this->prefix=$prefix;
	}

	/**
	 *	Sets postfix which will be added to uploaded files' names
	 *		@param postfix
	 */
	public function UsePostfix($postfix)
	{
		$this->postfix=$postfix;
	}

    /**
    *	Display the contents of the folder which files are uploaded to
	*/
	public function DisplayViewer()
	{
	   $output = '';
	   $output.= '<div id="uploader_viewer'.$this->id.'">';
	   $output.= self::ReadFiles($this->folder,$this->folder,$this->id,$this->path.'styles/no.gif',$this->maxNumFiles,$this->numViewerColumns);
	   $output = str_replace('FileName_ColumnHeader', $this->GetLocalizedString('FileName_ColumnHeader'), $output);
	   $output.= '</div>';
	   echo $output;
	}
	/**
    *	Gets folder separator used in current OS
	*/
    public static function GetFolderSeparator()
    {
    	if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN')
    	{
    		return '\\';
    	}
    	else
    	{
    		return '/';
    	}
    }
    /**
    *	Read the contents of the folder which files are uploaded to
	*/
	public static function ReadFiles($folder,$deleteFolder,$controlid,$imageSource,$maxNumFiles,$numColumns)
	{
	    $output = '';
	    $files=array();
		$i=0;
		$folder = dirname(__FILE__).self::GetFolderSeparator().$folder;
		if($hdl = opendir($folder)){
			while(false !== ($obj = readdir($hdl))){
				if($obj == '.' || $obj == '..' || $obj == '.htaccess' || is_dir($folder.self::GetFolderSeparator().$obj) === true) continue;
				if($maxNumFiles == 0)
					$files[$i++]=$obj;
				else
				{
					$stat = stat($folder.'/'.$obj);
					$files[$stat[9]]=$obj;
				}
			}
			closedir($hdl);


            ///////////////////FOR DEMO
            ksort($files);
            $extra = count($files)-$maxNumFiles;
			if($extra > 0 && $maxNumFiles != 0)
			{
               $i=0;
               foreach($files as $file)
               {
                   unlink($folder.'/'.$file);
                   $i++;
                   if($i==$extra)
                   		break;
               }
               for($j=0;$j<$extra;$j++)
			   		array_shift($files);
			}
            ////////////////////////////////
            if (count($files) % $numColumns === 0)
	            $pageSize = count($files) / $numColumns;
	        else $pageSize = floor(count($files) / $numColumns) + 1;
            $output.= '<table  border="1" class="ms-column5-main">';
			$output.= '<tr>';
			for ($j=0;$j<$numColumns;$j++)
				$output.= '<td class="ms-column5-top"></td><td class="ms-column5-top">FileName_ColumnHeader</td>';
			$output.= '</tr>';
            for ($i=0;$i<$pageSize;$i++)
   			{
   				$output.= '<tr>';
   				for ($j=0;$j<$numColumns;$j++)
   				{
   					$index = $j*$pageSize + $i;
   					if ($index >= count($files))
   						continue;
   					$files[$index]=str_replace("\\",'',$files[$index]);
                	$files[$index]=str_replace("'",'',$files[$index]);

					$output.= '<td class="ms-column5-even"><img alt="" onclick="uploader_unlink(\''.$deleteFolder.self::GetFolderSeparator().$files[$index].'\','.$controlid.')" class="commandimage" src="'.$imageSource.'" /></td>';
					$output.= '<td class="ms-column5-odd">'.$files[$index].'</td>';
   				}
   				$output.= '</tr>';
   			}
			$output.= '</table>';
		}
		return $output;
	}

	/**
     *	Gets a GET- or POST- parameter
     *      @param $key - parameter's key
     *	    @param $postbackMethod - postback method
    */
    public static function GetParam($key, $postbackMethod)
    {
        if(strtolower($postbackMethod)=='get') return isset($_GET[$key]) && self::CheckInput($_GET[$key]) ? $_GET[$key] : '';
        if(strtolower($postbackMethod)=='post') return isset($_POST[$key]) && self::CheckInput($_POST[$key]) ? $_POST[$key] : '';
        return isset($_REQUEST[$key]) && self::CheckInput($_REQUEST[$key]) ? $_REQUEST[$key] : '';
    }

    /**
    * Converts string like '12kb' to size in bytes
          @param $size
    *
    */
    private static function ConvertSizeToBytes($size)
    {
        $size=strtolower($size);
        $numofmatches = preg_match('/([0-9]*)([a-z]*)/', $size, $matches);
        if($numofmatches!=0)
        {
        	if($matches[2]=='' || $matches[2]=='b')
            	return $matches[1];
        	else if($matches[2]=='kb' || $matches[2]=='k')
           		return $matches[1] * 1024;
        	else if($matches[2]=='mb' || $matches[2]=='m')
           		return $matches[1] * 1024 * 1024;
        }
        return '';
    }

    /**
    *	Checks whether PECL UploadProgress extension is installed and working fine
    *
    */
    private function CheckUploadStatus()
    {
    	$templateini =  ini_get('uploadprogress.file.filename_template');
  		$testid = 'thisisjustatest';
  		$template = sprintf($templateini,$testid);
  		$templateerror = false;
  		if ($template && $template != $templateini && @touch ($template) && file_exists($template)) {
    		//    print '('.$templateini.' is writable. The realpath is ' . str_replace($testid,'%s',realpath($template)) .')';
        	unlink($template);
  		} else {
        	$templateerror = true;
  		}
        $this->progressMessage = '<font color=';
  	    if (function_exists('uploadprogress_get_info')) {
       		if ($templateerror) {
	        	$this->progressMessage .= '"red">Problem';
          		if ($template == $templateini) {
               		$this->progressMessage .= 'uploadprogress.file.filename_template ('.$templateini.') doesn\'t have an %s in it for making unique temporary files. Please adjust.<br/>';
               		$this->showingProgress = false;
           	   	} else {
               		$this->progressMessage .= $templateini. ' is NOT writable. <br/>Please make sure the directory exists and is writable for the webserver. <br/>';
                    $this->progressMessage .= 'Or adjust the ini setting \'uploadprogress.file.filename_template\' to a correct path.';
                    $this->showingProgress = false;
           		}
       		} else {
           		$this->progressMessage .= '"green">The uploadprogress extension is installed and initial checks show it is working';
       		}
       	}
       	else
       	{
       		$this->progressMessage .= '"red">The uploadprogress extension is not installed.';
       		$this->showingProgress = false;
       	}
       	$this->progressMessage .= '</font>';
    }

    /**
    * Chooses an icon according to file extension
    *
    */
    private static function ChooseIcon($path,$filename)
    {
        $source = $path.'styles/extensions/';
        $extension = substr(strrchr($filename,'.'),1);
	    switch($extension)
    	{
     		case 'txt': $source .= 'text.gif'; break;
            case 'doc': $source .= 'doc.gif'; break;
	        case 'jpg': $source .= 'jpeg.gif'; break;
	        case 'jpeg': $source .= 'jpeg.gif'; break;
	        case 'gif': $source .= 'gif.gif'; break;
	        case 'png': $source .= 'gif.gif'; break;
	        case 'htm': $source .= 'html.gif'; break;
	        case 'html': $source .= 'html.gif'; break;
	        case 'bmp': $source .= 'bitmap.gif'; break;
	        case 'rar':
	        case 'zip': $source .= 'rar.gif'; break;
	        case 'xml': $source .= 'xml.gif'; break;
	        default: $source .= 'unknown.gif';
        }
       return $source;
    }

    /**
     *	Checks input string for suspicious code
     *      @param $input - input string
     *	    @param $level - security level
    */
    private static function CheckInput($input, $level = 'medium')
    {
        if($input == '') return true;
        $error = 0;
        $bad_string = array('%20union%20', ' /*', '*/ union /*', '+union+', 'load_file', 'outfile', 'document.cookie', 'onmouse', '<script', '<iframe', '<applet', '<meta', '<style', '<form', '<img', '<body', '<link', '_GLOBALS', '_REQUEST', '_GET', '_POST', 'include_path', 'prefix', 'http://', 'https://', 'ftp://', 'smb://' );
        foreach($bad_string as $string_value)
        {
            if(strstr($input, $string_value)) $error = 1;
        }
        if((preg_match('/<[^>]*script*\"?[^>]*>/i', $input)) ||
        (preg_match('/<[^>]*object*\"?[^>]*>/i', $input)) ||
        (preg_match('/<[^>]*iframe*\"?[^>]*>/i', $input)) ||
        (preg_match('/<[^>]*applet*\"?[^>]*>/i', $input)) ||
        (preg_match('/<[^>]*meta*\"?[^>]*>/i', $input)) ||
        (preg_match('/<[^>]*style*\"?[^>]*>/i', $input)) ||
        (preg_match('/<[^>]*form*\"?[^>]*>/i', $input)) ||
        (preg_match('/<[^>]*img*\"?[^>]*>/i', $input)) ||
        (preg_match('/<[^>]*onmouseover*\"?[^>]*>/i', $input)) ||
        (preg_match('/<[^>]*body*\"?[^>]*>/i', $input)) ||
        (preg_match('/\([^>]*\"?[^)]*\)/i', $input)) ||
        (preg_match('/ftp:\/\//i', $input)) ||
        (preg_match('/https:\/\//i', $input)) ||
        (preg_match('/http:\/\//i', $input)) )
        {
            $error = 1;
        }
        $ss = $_SERVER['HTTP_USER_AGENT'];
        if((preg_match('/libwww/i',$ss)) ||
        (preg_match('/^lwp/i',$ss))  ||
        (preg_match('/^Jigsaw/i',$ss)) ||
        (preg_match('/^Wget/i',$ss)) ||
        (preg_match('/^Indy\ Library/i',$ss)) )
        {
            $error = 1;
        }
        if($error){
            return false;
        }
        return true;
    }
}
?>